<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page.sync="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
      </template>

      <template slot="orderStateDesc" slot-scope="scope" >
        <el-tag v-if="scope.row.orderState === 1">{{scope.row.orderStateDesc}}</el-tag>
        <el-tag v-else-if="scope.row.orderState === 2" type="warning">{{scope.row.orderStateDesc}}</el-tag>
        <el-tag v-else-if="scope.row.orderState === 3" type="warning">{{scope.row.orderStateDesc}}</el-tag>
        <el-tag v-else-if="scope.row.orderState === 4" type="success">{{scope.row.orderStateDesc}}</el-tag>
        <el-tag v-else-if="scope.row.orderState === 5" type="danger">{{scope.row.orderStateDesc}}</el-tag>
<!--        <el-tag v-else-if="scope.row.orderState === 6" type="danger">{{scope.row.orderStateDesc}}</el-tag>-->
<!--        <el-tag v-else-if="scope.row.orderState === 7" type="danger">{{scope.row.orderStateDesc}}</el-tag>-->
        <el-tag v-else-if="scope.row.orderState === 8" type="danger">{{scope.row.orderStateDesc}}</el-tag>
      </template>

    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove, refund} from "@/api/finance/order";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          searchIcon: true,
          searchIndex: 3,
          menuWidth: 130,
          border: true,
          viewBtn: true,
          editBtn: false,
          delBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "订单号",
              prop: "orderNo",
              search: true,
              // width: 170,
            },
            {
              label: "订单来源",
              // width: 100,
              prop: "source",
              type: "select",
              search: true,
              dicUrl: "/api/blade-system/dict-biz/getEnumDict?enumName=OrderSourceEnum",
              props: {
                label: "name",
                value: "value"
              },
              dataType: "number",
            },
            {
              label: "订单类型",
              prop: "orderType",
              type: "select",
              search: true,
              dicUrl: "/api/blade-system/dict-biz/dictionary?code=order_type",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              dataType: "number",
            },
            {
              label: "买家昵称",
              prop: "nickname",
              search: true,
            },
            // {
            //   label: "订单状态",
            //   prop: "orderState",
            //   type: "select",
            //   search: true,
            //   hide: true,
            //   dicUrl: "/api/blade-system/dict-biz/dictionary?code=order_state",
            //   props: {
            //     label: "dictValue",
            //     value: "dictKey"
            //   },
            //   dataType: "number",
            // },

            {
              label: "总金额",
              prop: "totalAmount",
              hide: true,
              rules: [{
                required: true,
                message: "请输入总金额",
                trigger: "blur"
              }]
            },
            {
              label: "订单金额",
              prop: "paymentAmount",
              formatter:(val,value,label)=>{
                  return "￥" + value;
              },
            },
            {
              label: "支付方式",
              prop: "paymentMode",
              hide: true,
              rules: [{
                required: true,
                message: "请输入支付方式",
                trigger: "blur"
              }]
            },
            {
              label: "订单状态",
              prop: "orderStateDesc",
              slot:true,
              // width: 80
            },
            {
              label: "支付时间",
              prop: "paymentTime",
              hide: true,
              rules: [{
                required: true,
                message: "请输入支付时间",
                trigger: "blur"
              }]
            },
            {
              label: "支付状态",
              prop: "paymentState",
              hide: true
            },
            {
              label: "优惠金额",
              prop: "discountAmount",
              hide: true,
              rules: [{
                required: true,
                message: "请输入优惠金额",
                trigger: "blur"
              }]
            },
            {
              label: "是否售后",
              prop: "isAftersales",
              hide: true,
              type: "select",
              dicUrl: "/api/blade-system/dict/dictionary?code=yes_no",
              props: {
                label: "dictValue",
                value: "dictKey"
              },
              // dataType: "number",
            },
            {
              label: "发货时间",
              prop: "sendTime",
              hide: true,
            },
            {
              label: "收货时间",
              prop: "recordTime",
              hide: true,
            },
            {
              label: "下单时间",
              prop: "createTime"
            },
            {
              label: "下单时间",
              prop: "orderTimeRange",
              // width: 150,
              display: false,
              hide: true,
              search: true,
              type: 'datetimerange',
              searchRange:true,
              defaultTime:['00:00:00', '23:59:59'],
              format:'yyyy-MM-dd HH:mm:ss',
              valueFormat:'yyyy-MM-dd HH:mm:ss',
              startPlaceholder: '开始时间',
              endPlaceholder: '结束时间',
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.order_add, false),
          viewBtn: this.vaildData(this.permission.order_view, false),
          delBtn: this.vaildData(this.permission.order_delete, false),
          editBtn: this.vaildData(this.permission.order_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        const orderTimeRange = this.query.orderTimeRange;
        if (orderTimeRange) {
          this.query.startTime = orderTimeRange[0];
          this.query.endTime = orderTimeRange[1];
        }
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      },

    }
  };
</script>

<style>
</style>
